<template>
  <div class="all-tab-container">
    <PageList
      :items="items"
      v-if="!showDetail"
      @check="data => showDetailPage(data)"
    ></PageList>
    <ExperimentMark
      v-if="showDetail"
      :markData="markData"
      @commitMark="commitMark"
      @cancel="cancalMark"
    ></ExperimentMark>
  </div>
</template>

<script>
import { answersheets } from "@/api";
import PageList from "./components/pageList";
import ExperimentMark from "./experimentMark";
import dayjs from "dayjs";
import MessagesDialog from "@/mixins/messagesDialog";

export default {
  name: "newTabs",
  components: { PageList, ExperimentMark },
  data() {
    return {
      items: [],
      showDetail: false,
      markData: {
        account: undefined,
        answers: undefined,
        createdAt: undefined,
        isEnd: undefined,
        name: undefined,
        score: undefined,
        total: undefined,
        updatedAt: undefined
      }
    };
  },
  mixins: [MessagesDialog],
  methods: {
    async fetchAnswerSheetList() {
      let result = await answersheets.list({
        filters: {
          include: ["account"],
          where: {
            isEnd: false
          },
          order: [
            {
              key: "createdAt",
              sort: "desc"
            }
          ]
        }
      });
      result.items.forEach(item => this.answersheetFormat(item));
      this.items = result.items;
    },
    async fetchAnswerSheetItemDetail(data) {
      const res = await answersheets.detail(data.id, {
        filters: {
          include: [
            "account",
            "lab",
            {
              association: "answers",
              include: ["question"]
            }
          ]
        }
      });
      this.markData = res;
    },
    answersheetFormat(item) {
      item.name = item.account.name;
      item.createdAt = dayjs(item.createdAt).format("YYYY-MM-DD HH:mm:ss");
    },
    async showDetailPage(data) {
      await this.fetchAnswerSheetItemDetail(data);
      this.showDetail = true;
    },
    async commitMark(data) {
      const answerSheetItems = data.map(data => {
        return {
          id: data.id,
          comment: data.comment,
          score: data.score
        };
      });
      const items = {
        id: data[0].answersheet_id,
        answerSheetItems
      };
      try {
        await answersheets.update(items);
        this.successDialog("审批成功！");
        await this.fetchAnswerSheetItemDetail(items);
        this.mark = false;
        // this.markData = null;
      } catch (err) {
        await this.fetchAnswerSheetItemDetail(items);
        this.errorDialog(err);
      }
    },
    async cancalMark() {
      await this.fetchAnswerSheetList();
      this.showDetail = false;
    }
  },
  async created() {
    await this.fetchAnswerSheetList();
  }
};
</script>
